"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }// src/index.ts
var _argon2browser = require('argon2-browser'); var _argon2browser2 = _interopRequireDefault(_argon2browser);
var _randombytes = require('randombytes'); var _randombytes2 = _interopRequireDefault(_randombytes);
var _tschacha20 = require('ts-chacha20');
async function argon2({ password, salt }) {
  const result = await _argon2browser2.default.hash({
    pass: password,
    salt,
    hashLen: 32,
    time: 2,
    mem: 32,
    parallelism: 1,
    type: _argon2browser2.default.ArgonType.Argon2d
  });
  return Buffer.from(result.hash);
}
function generateRandom(length = 16) {
  return Uint8Array.from(_randombytes2.default.call(void 0, length));
}
async function encrypt(data, password) {
  const salt = generateRandom(12);
  const key = await argon2({ password, salt });
  const encrypt2 = new (0, _tschacha20.Chacha20)(key, salt).encrypt(
    Buffer.from(data, "utf8")
  );
  const packaged = Buffer.from([...salt, ...encrypt2]);
  return packaged.toString("base64");
}
async function decrypt(data, password) {
  const unpackaged = Buffer.from(data, "base64");
  const salt = unpackaged.subarray(0, 12);
  const input = unpackaged.subarray(12, data.length);
  const key = await argon2({ password, salt });
  const message = new (0, _tschacha20.Chacha20)(key, salt).decrypt(input);
  return Buffer.from(message).toString("utf8");
}




exports.argon2 = argon2; exports.decrypt = decrypt; exports.encrypt = encrypt;
